﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Threading.Tasks;
using System.Windows;
using Selectron_C_Bus_Calculator.View;

namespace Selectron_C_Bus_Calculator.Model
{
    public class Startup
    {
        //Initialise other Classes
        XmlDocument doc = new XmlDocument();
        //PowerCalculatorView view = new PowerCalculatorView();

        //This Public Dictionary is for saving all the Nodes
        public Dictionary<string, Nodes> nodes = new Dictionary<string, Nodes>();

        //This List will be displayed in the Node Combobox
        public List<string> node_key = new List<string>();

        public void startup()
        {
            //Try to Load the XML File 
            try
            {
                doc.Load(@".\XML File\ModulList.xml");
            }

            //When the File wasnt Found or a error is in the File a MessageBox will apear and the Programm will be stopped
            catch (Exception ex)
            {
                //When the XML wasnt found this MesassgeBox will show up
                if (ex is System.IO.FileNotFoundException)
                {
                    MessageBox.Show("XML File 'ModulList' not Found. Please Contact Support.",
                        "XML File not Found");
                }

                //and when there is an error in the File this Box will show up
                if (ex is System.Xml.XmlException)
                {
                    MessageBox.Show("Error in XML File 'ModulList'",
                        "Error in XML File");
                }

                //At the End the programm will be stoped
                Environment.Exit(0);
            }

            try
            {
                //Read the Text inside the Node section
                foreach (XmlNode node in doc.DocumentElement.SelectSingleNode("/Modullist/Modules/Nodes"))
                {
                    //Here the information about the Node is read and saved
                    Nodes newnode = new Selectron_C_Bus_Calculator.Model.Nodes(
                        node.Attributes["Name"]?.InnerText,
                        Convert.ToInt32(node.Attributes["Artnr"]?.InnerText),
                        Convert.ToInt32(node.Attributes["Maxpowerextbus_mw"]?.InnerText),
                        node.Attributes["MAS"]?.InnerText,
                        Convert.ToInt32(node.Attributes["Maxmodulecount"]?.InnerText)
                        );

                    //Add the Nodes to the Combobox
                    //PowerCalculatorView =  view.Node.Items.Add("Hallo");

                    node_key.Add(node.Attributes["Name"]?.InnerText);

                    nodes.Add(node.Attributes["Name"]?.InnerText, newnode);

                }
            }

            //When an error apears while the XMl is readout a Message box will show up and the Programm will be stoped.
            catch (/*NullReferenceException*/XmlException)
            {
                MessageBox.Show("Error in XML File 'ModulList'", "Error in XML File");

                Environment.Exit(0);
            }
        }
    }
}
